<template>
    <FormComponent
        :classImg="classImg"
        :title="title"
        :formFirstTabIsValid="formEntidadIsValid"
        @save="save()"
    >
        <template #tab-1>
            <div class="row div-reg">
                <div class="col form-group">
                    <SelectDepartamentoComponent
                        v-model="id_departamento"
                        :ruta="ruta"
                        :error="errorsBack.id_departamento"
                        @change="getMunicipios()"
                    />
                </div>
                <div class="col form-group">
                    <SelectMunicipioComponent
                        v-model="id_municipio"
                        :municipios="municipios"
                        :error="errorsBack.id_municipio"
                        @change="getEntidades()"
                    />
                </div>
            </div>
        
            <div class="row div-reg">
                <div class="col form-group">
                    <SelectEntidadComponent
                        v-model="entidadForm.id_entidad"
                        :error="errorsBack.id_entidad"
                        :entidades="entidades"
                    />
                </div>
            </div>
        </template>

        <template #tab-2>
            <form>
                <div class="row div-reg">
                    <div class="col form-group">
                        <InputTextComponent
                            label="Nombre(s)"
                            v-model="userForm.nombres_usuario"
                            placeholder="Introduzca Nombre(s)"
                            :error="errorsBack.nombres_usuario"
                        />
                    </div>
                    <div class="col form-group">
                        <InputTextComponent
                            label="Apellidos"
                            v-model="userForm.apellidos_usuario"
                            placeholder="Introduzca Apellidos"
                            :error="errorsBack.apellidos_usuario"
                        />
                    </div>
                </div>
                <div class="row div-reg">
                    <div class="col form-group">
                        <InputTextComponent
                            label="Número de Identificacion"
                            v-model="userForm.cedula_usuario"
                            placeholder="Introduzca Identificacion"
                            :error="errorsBack.cedula_usuario"
                            onlyNumbers
                        />
                    </div>
                    <div class="col form-group">
                        <InputTextComponent
                            label="Telefono"
                            v-model="userForm.telefono_usuario"
                            placeholder="Introduzca Telefono"
                            :error="errorsBack.telefono_usuario"
                            onlyNumbers
                            :limitCharacters="10"
                        />
                    </div>
                </div>
                <div class="row div-reg">
                    <div class="col form-group">
                        <InputTextComponent
                            label="Correo Electronico"
                            v-model="userForm.email"
                            placeholder="Introduzca Correo Electronico"
                            :error="errorsBack.email"
                        />
                    </div>
                </div>
                <div class="row div-reg">
                    <div class="col form-group mb-4">
                        <InputTextComponent
                            label="Contraseña"
                            type="password"
                            v-model="userForm.password"
                            placeholder="Introduzca tu contraseña"
                            :error="errorsBack.password"
                            autocomplete=""
                        />
                    </div>
                    <div class="col form-group mb-4">
                        <InputTextComponent
                            label="Contraseña"
                            type="password"
                            v-model="password"
                            placeholder="Repite tu contraseña"
                            :error="errorsBack.repeatPassword"
                            autocomplete=""
                        />
                    </div>
                </div>
            </form>
        </template>
    </FormComponent>
</template>

<script>
import FormComponent               from './../../../components/formComponent.vue';
import SelectDepartamentoComponent from './../../../components/selectDepartamentoComponent.vue';
import SelectMunicipioComponent    from './../../../components/selectMunicipioComponent.vue';
import SelectEntidadComponent      from './../../../components/selectEntidadComponent.vue';
import InputTextComponent          from './../../../components/inputTextComponent.vue';
import { invalidEmail }            from './../../../utils/emailChecker';
import { isEmpty }                 from './../../../utils/isEmpty';

export default {

    props: {
        ruta: {
            type: String
        },
        title: {
            type: String,
            default: "Title"
        },
        classImg: {
            type: String,
            default: ""
        }
    },

    components: {
        FormComponent,
        SelectDepartamentoComponent,
        SelectMunicipioComponent,
        SelectEntidadComponent,
        InputTextComponent
    },

    data: () => {
        return {
            municipios: [],
            entidades: [],
            password: "",
            id_departamento: 0,
            id_municipio: 0,
            entidadForm: {
                id_entidad: 0
            },
            userForm: {
                cedula_usuario: "",
                nombres_usuario: "",
                apellidos_usuario: "",
                telefono_usuario: "",
                email: "",
                password: "",
                id_estado: 1,
            },
            errorsBack: {
                id_departamento: "",
                id_municipio: "",
                id_entidad: "",
                cedula_usuario: "",
                nombres_usuario: "",
                apellidos_usuario: "",
                telefono_usuario: "",
                email: "",
                password: "",
                repeatPassword: ""
            }
        }
    },

    created() {

    },

    methods: {

        async getMunicipios() {

            this.id_municipio = 0;
            this.entidadForm.id_entidad = 0;

            const response = await axios.get(this.ruta + 
                `/api/municipios?filter[idDepartamento]=${this.id_departamento}`
            );

            this.municipios = response.data['data'];
        },

        async getEntidades() {

            this.entidadForm.id_entidad = 0;

            const ESTADO_ACTIVO = 2;

            const response = await axios.get(this.ruta + 
                `/api/entidades?filter[idMunicipio]=${this.id_municipio}&filter[idEstado]=${ESTADO_ACTIVO}`
            );

            this.entidades = response.data['data'];
        },

        reserErrors() {
            Object.entries(this.errorsBack)
                .forEach(([key, value]) => this.errorsBack[key] = "");
        },

        async save() {

            this.reserErrors();
            if (this.formUsuarioIsInvalid()) return;
            
            try {

                const response = await axios.post(
                    this.ruta + '/api/usuarios', { ...this.entidadForm, ...this.userForm }
                );

                this.$utils.showWarning(response.data['message']);
                this.$router.push({ name: 'login' });

            } catch (error) {

                const errorRequest = JSON.parse(error.request.response);

                Object.entries(errorRequest['errors'])
                    .forEach(([key, value]) => this.errorsBack[key] = value[0]);          
            }
        },

        formEntidadIsValid() {

            var errorCount = 0;
            this.reserErrors();

            if (this.id_departamento == 0) {
                this.errorsBack.id_departamento = "Departamento es requerido";
                errorCount++;            
            }

            if (this.id_municipio == 0) {
                this.errorsBack.id_municipio = "Municipio es requerido";
                errorCount++;            
            }

            if (this.entidadForm.id_entidad == 0) {
                this.errorsBack.id_entidad = "Entidad es requerido";
                errorCount++;            
            }

            return errorCount == 0;
        },

        formUsuarioIsInvalid() {

            var errorCount = 0;
            this.reserErrors();

            if (isEmpty(this.userForm.nombres_usuario)) {
                this.errorsBack.nombres_usuario = "Nombres es requerido";
                errorCount++;            
            }

            if (isEmpty(this.userForm.apellidos_usuario)) {
                this.errorsBack.apellidos_usuario = "Apellidos es requerido";
                errorCount++;            
            }

            if (isEmpty(this.userForm.cedula_usuario)) {
                this.errorsBack.cedula_usuario = "Cédula es requerido";
                errorCount++;            
            }

            if (isEmpty(this.userForm.telefono_usuario)) {
                this.errorsBack.telefono_usuario = "Teléfono es requerido";
                errorCount++;            
            }

            if (isEmpty(this.userForm.email)) {
                this.errorsBack.email = "Correo es requerido";
                errorCount++;            
            }

            if (invalidEmail(this.userForm.email)) {
                this.errorsBack.email = "Correo inválido";
                errorCount++;     
            }

            if (isEmpty(this.userForm.password)) {
                this.errorsBack.password = "Contraseña es requerido";
                errorCount++;            
            }

            if (isEmpty(this.password)) {
                this.errorsBack.repeatPassword = "Confirmar contrseña es requerido";
                errorCount++;            
            }

            if (this.password != this.userForm.password) {
                this.errorsBack.repeatPassword = "Contraseña no coincide";
                errorCount++;            
            }

            return errorCount > 0;
        }
    }
}
</script>